zoukankan      html  css  js  c++  java
  • Codeforces Round #379 (Div. 2) C. Anton and Making Potions 二分

    C. Anton and Making Potions
    time limit per test
    4 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Anton is playing a very interesting computer game, but now he is stuck at one of the levels. To pass to the next level he has to prepare npotions.

    Anton has a special kettle, that can prepare one potions in x seconds. Also, he knows spells of two types that can faster the process of preparing potions.

    1. Spells of this type speed up the preparation time of one potion. There are m spells of this type, the i-th of them costs bi manapoints and changes the preparation time of each potion to ai instead of x.
    2. Spells of this type immediately prepare some number of potions. There are k such spells, the i-th of them costs di manapoints and instantly create ci potions.

    Anton can use no more than one spell of the first type and no more than one spell of the second type, and the total number of manapoints spent should not exceed s. Consider that all spells are used instantly and right before Anton starts to prepare potions.

    Anton wants to get to the next level as fast as possible, so he is interested in the minimum number of time he needs to spent in order to prepare at least n potions.

    Input

    The first line of the input contains three integers nmk (1 ≤ n ≤ 2·109, 1 ≤ m, k ≤ 2·105) — the number of potions, Anton has to make, the number of spells of the first type and the number of spells of the second type.

    The second line of the input contains two integers x and s (2 ≤ x ≤ 2·109, 1 ≤ s ≤ 2·109) — the initial number of seconds required to prepare one potion and the number of manapoints Anton can use.

    The third line contains m integers ai (1 ≤ ai < x) — the number of seconds it will take to prepare one potion if the i-th spell of the first type is used.

    The fourth line contains m integers bi (1 ≤ bi ≤ 2·109) — the number of manapoints to use the i-th spell of the first type.

    There are k integers ci (1 ≤ ci ≤ n) in the fifth line — the number of potions that will be immediately created if the i-th spell of the second type is used. It's guaranteed that ci are not decreasing, i.e. ci ≤ cj if i < j.

    The sixth line contains k integers di (1 ≤ di ≤ 2·109) — the number of manapoints required to use the i-th spell of the second type. It's guaranteed that di are not decreasing, i.e. di ≤ dj if i < j.

    Output

    Print one integer — the minimum time one has to spent in order to prepare n potions.

    Examples
    input
    20 3 2
    10 99
    2 4 3
    20 10 40
    4 15
    10 80
    output
    20
    input
    20 3 2
    10 99
    2 4 3
    200 100 400
    4 15
    100 800
    output
    200
    Note

    In the first sample, the optimum answer is to use the second spell of the first type that costs 10 manapoints. Thus, the preparation time of each potion changes to 4 seconds. Also, Anton should use the second spell of the second type to instantly prepare 15 potions spending 80 manapoints. The total number of manapoints used is 10 + 80 = 90, and the preparation time is 4·5 = 20 seconds (15potions were prepared instantly, and the remaining 5 will take 4 seconds each).

    In the second sample, Anton can't use any of the spells, so he just prepares 20 potions, spending 10 seconds on each of them and the answer is 20·10 = 200.

    题意:你需要n个魔法,你制造一个魔法的时间为x,并且你有s点法力值;

       现在有两个商店,你在一个商店最多买一个物品,可以不买;

       第一个商店有m个物品,每个物品花费b[i]法力值,可以将x降为a[i];

       第二个商店有k个物品,每个物品花费d[i]法力值,可以制造c[i]个魔法;

       求得到n个魔法的最小时间;cd有序;

    思路:暴力取a,b,二分,得到最大的d,既可以得到最大的c;

       注意ab可能不取;

    #include<bits/stdc++.h>
    using namespace std;
    #define ll long long
    #define pi (4*atan(1.0))
    #define eps 1e-14
    const int N=2e5+10,M=1e6+10,inf=1e9+10;
    const ll INF=1e18+10,mod=2147493647;
    ll n,m,k;
    ll x,s;
    ll a[N],b[N],c[N],d[N];
    int main()
    {
        scanf("%lld%lld%lld",&n,&m,&k);
        scanf("%lld%lld",&x,&s);
        for(int i=1;i<=m;i++)
            scanf("%lld",&a[i]);
        for(int i=1;i<=m;i++)
            scanf("%lld",&b[i]);
        for(int i=1;i<=k;i++)
            scanf("%lld",&c[i]);
        for(int i=1;i<=k;i++)
            scanf("%lld",&d[i]);
        d[k+1]=INF;
        ll ans=x*n;
        for(int i=1;i<=m;i++)
        {
            ll sum=0,temp=s,xx=x,nn=n;
            if(temp>=b[i])
                temp-=b[i],xx=a[i];
            int pos=upper_bound(d+1,d+1+k,temp)-d-1;
            if(pos!=0)
                nn-=c[pos];
            ans=min(ans,nn*xx);
            //cout<<nn<<" "<<xx<<" "<<pos<<endl;
        }
        int pos=upper_bound(d+1,d+1+k,s)-d-1;
        n-=c[pos];
        ans=min(ans,n*x);
        printf("%lld
    ",ans);
        return 0;
    }
  • 相关阅读:
    初学者bootstrap(五)JavaScript插件(上)在路上(6)
    初学者bootstrap(三)下载与安装在路上(7)
    Viewport响应式 Web 设计在路上(13)
    初学者动画(一)在路上(3)
    svn添加强制注释,precommit结合python
    ftpclient卡死问题
    @Transactional失效的问题
    javamail发送二进制流附件的问题
    springmvc附件上传核心代码
    kafka集群配置与测试
  • 原文地址:https://www.cnblogs.com/jhz033/p/6069984.html
Copyright © 2011-2022 走看看